let collect_collisions hash file =
  let table = Hashtbl.create 16 in
  let cin = open_in file in
  let rec loop () =
    match In_channel.input_line cin with
    | None -> table
    | Some w ->
      let h = hash w in
      let collisions = try Hashtbl.find table h with Not_found -> [] in
      if not (List.mem w collisions) then
        Hashtbl.replace table h (w::collisions);
      loop ()
  in
  loop ()

let display_collisions table =
  let max_collisions = ref 0 in
  let num_collisions = ref 0 in
  Hashtbl.iter (fun k l ->
      let n = List.length l in
      if n >= 2 then begin
        let s = String.concat "; " l in
        Printf.printf "%d (%d) -> %s\n" k n s;
        num_collisions := !num_collisions + 1;
        max_collisions := max !max_collisions n;
      end
    ) table;
    Printf.printf "Plus grande collision: %d\n" !max_collisions;
    Printf.printf "Nombre total de collisions: %d\n" !num_collisions

let java_hash s =
  let h = ref 0 in
  for i = 0 to String.length s - 1 do
    h := !h + 31 * Char.code s.[i]
  done;
  !h

let () =
  let table = collect_collisions Hashtbl.hash "french.txt" in
  display_collisions table